## regina-normal 7.3

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 3.12)
PROJECT (regina)

# Let the user override the package name.
IF(NOT PACKAGE_NAME)
  SET (PACKAGE_NAME regina CACHE STRING
    "The package name used for installation directories.  On some platforms this is 'regina-normal', not 'regina', to avoid conflicts with other software with the same name."
    FORCE)
ENDIF(NOT PACKAGE_NAME)

SET (PACKAGE_PRETTY_NAME Regina)
# Look here for Find___.cmake modules
SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

# Regina's own cmake scripts:
INCLUDE( ReginaMacros )

# Version
SET (PACKAGE_VERSION 7.3)
SET (SNAPPY_VERSION 2.8)
SET (PACKAGE_STRING "${PACKAGE_PRETTY_NAME} ${PACKAGE_VERSION}")

# Extract major/minor version
# Note: The PACKAGE_VERSION_MAJOR "output" is discarded, since it matches the
# whole string
STRING(REGEX MATCH "^([0-9]+).([0-9]+)" PACKAGE_VERSION_MAJOR "${PACKAGE_VERSION}")
SET (PACKAGE_VERSION_MAJOR ${CMAKE_MATCH_1} )
SET (PACKAGE_VERSION_MINOR ${CMAKE_MATCH_2} )

IF(BUILD_INFO)
  SET (PACKAGE_BUILD_STRING "${PACKAGE_STRING} (${BUILD_INFO})")
ELSE(BUILD_INFO)
  SET (BUILD_INFO "" CACHE STRING
    "Optional additional information about this specific build.  Examples might be: \"Official macOS build\", or \"Debian package build\"."
  FORCE)
  SET (PACKAGE_BUILD_STRING "${PACKAGE_STRING}")
ENDIF(BUILD_INFO)
REGINA_ESCAPE_C (BUILD_INFO)
REGINA_ESCAPE_C (PACKAGE_BUILD_STRING)
MESSAGE (STATUS "Detailed version: ${PACKAGE_BUILD_STRING}")

# Make a release build by default.
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build.  Options are: Debug Release RelWithDebInfo MinSizeRel."
  FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

SET(HIGHDIM "OFF" CACHE BOOL INTERNAL)
IF(HIGHDIM)
  MESSAGE (STATUS "Dimensions 9-15: enabled")
  SET (REGINA_HIGHDIM TRUE)
ELSE(HIGHDIM)
  MESSAGE (STATUS "Dimensions 9-15: disabled for performance - to enable these, pass -DHIGHDIM=1")
  SET (REGINA_HIGHDIM FALSE)
ENDIF(HIGHDIM)

# Every year I swear I will drop windows support, and this year is no different.
# The windows build (as of November 2015) crashes in the test suite with -O3.
# It looks as though this might be a compiler problem: the ipa-cp-clone
# optimisation has been known to cause crashes under mingw in other projects
# in the past also.
IF (WIN32)
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-ipa-cp-clone")
ENDIF (WIN32)

# Distinguish between the different Regina installation types:
# XDG = standard freedesktop.org filesystem installation in a fixed location.
# HPC = filesystem installation suitable for HPC systems where there is
#       no need for a GUI or HTML documentation, and where you do not have root.
# Windows = self-contained movable install directory for MS Windows.
if (NOT REGINA_INSTALL_TYPE)
  if (WIN32)
    SET (REGINA_DEFAULT_INSTALL_TYPE Windows)
  else ()
    SET (REGINA_DEFAULT_INSTALL_TYPE XDG)
  endif ()
  SET (REGINA_INSTALL_TYPE ${REGINA_DEFAULT_INSTALL_TYPE} CACHE STRING
    "Choose how Regina installs itself.  Options are: XDG HPC Windows."
    FORCE)
ENDIF (NOT REGINA_INSTALL_TYPE)
MESSAGE (STATUS "Regina install type: ${REGINA_INSTALL_TYPE}")

# Sanity check the installation type, and set the boolean install type flags
# that will appear in regina-config.h.
# Note: even though Bundle is not supported in CMake, we must keep the flag
# here because the Xcode build uses it (via the corresponding #define).
SET(REGINA_INSTALL_XDG FALSE)
SET(REGINA_INSTALL_HPC FALSE)
SET(REGINA_INSTALL_BUNDLE FALSE)
SET(REGINA_INSTALL_WINDOWS FALSE)
IF (${REGINA_INSTALL_TYPE} STREQUAL XDG)
  # No sanity checking needed here (yet).
  SET(REGINA_INSTALL_XDG TRUE)
ELSEIF (${REGINA_INSTALL_TYPE} STREQUAL HPC)
  # No sanity checking needed here either.
  SET(REGINA_INSTALL_HPC TRUE)
ELSEIF (${REGINA_INSTALL_TYPE} STREQUAL Bundle)
  MESSAGE(FATAL_ERROR
    "REGINA_INSTALL_TYPE=Bundle is no longer supported. These CMake build scripts will give a unix-style installation in a fixed location; for a standalone macOS app bundle please use Xcode instead.")
ELSEIF (${REGINA_INSTALL_TYPE} STREQUAL Windows)
  IF (NOT WIN32)
    MESSAGE(FATAL_ERROR
      "REGINA_INSTALL_TYPE=Windows is only supported on MS Windows.")
  ENDIF (NOT WIN32)
  SET(REGINA_INSTALL_WINDOWS TRUE)
ELSE()
  MESSAGE(FATAL_ERROR
    "REGINA_INSTALL_TYPE must be XDG, HPC or Windows.")
ENDIF()

IF(NOT (WIN32 OR APPLE))
  CHECK_LSB_RELEASE()
ENDIF(NOT (WIN32 OR APPLE))

# Are we installing development files?
SET (REGINA_INSTALL_DEV ON)

# Give packagers a way of insisting that every optional component is found.
# Set PACKAGING_MODE=1 to make every component compulsory.
IF(NOT PACKAGING_MODE)
  SET (PACKAGING_MODE OFF CACHE STRING
    "Makes all optional components mandatory, so that cmake will fail if any optional component is not found."
    FORCE)
ENDIF(NOT PACKAGING_MODE)
IF(PACKAGING_MODE)
  SET(REGINA_MANDATORY TRUE)
ELSE(PACKAGING_MODE)
  SET(REGINA_MANDATORY FALSE)
ENDIF(PACKAGING_MODE)

# Options that indicate how python is shipped.
IF(NOT PYTHON_CORE_IN_ZIP)
  SET (PYTHON_CORE_IN_ZIP OFF CACHE STRING
    "Indicates that Regina ships its own Python, with the core Python libraries in pythonXY.zip."
    FORCE)
ENDIF(NOT PYTHON_CORE_IN_ZIP)

# The iOS build of Regina links the python module directly into the GUI,
# and there is a flag in regina-config.h to indicate this.
# Such a configuration is not, however, supported by regina's cmake build
# system, and so we do not allow cmake users to enable it.
SET (PYTHON_STATIC_LINK OFF)

# For pretty logging of optional features at the end of the cmake run:
INCLUDE(MacroLogFeature)

# Modules needed for IOS check and function existence
INCLUDE( CheckCXXSourceCompiles )
INCLUDE( CheckFunctionExists )

# We need to determine threading flags *before* testing for C++11 std::thread.
FIND_PACKAGE(Threads REQUIRED)
IF(NOT Threads_FOUND)
  MESSAGE(FATAL_ERROR "Regina requires threading support.")
ENDIF(NOT Threads_FOUND)
IF(CMAKE_COMPILER_IS_GNUCXX)
  # The FindThreads module picks up -lpthread, not -pthread.
  # This is unfortunate, because std::thread must be built with -pthread
  # under g++; otherwise it builds but throws an exception at runtime.
  SET(CMAKE_CXX_FLAGS "-pthread ${CMAKE_CXX_FLAGS}")
ENDIF(CMAKE_COMPILER_IS_GNUCXX)

# Make everything use C++17 (or later).
SET(CMAKE_CXX_STANDARD 17)
SET(CMAKE_CXX_STANDARD_REQUIRED YES)
SET(CMAKE_CXX_EXTENSIONS OFF)

CHECK_STDFS()
IF (NOT STDFS_FOUND)
  MESSAGE(FATAL_ERROR "Your compiler does not appear to support either the C++17 std::filesystem or the alternative std::experimental::filesystem.")
ENDIF (NOT STDFS_FOUND)

# Always include . in the header search path:
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Installation directories
SET (APPDIR "${CMAKE_INSTALL_PREFIX}/bin")
SET (BINDIR "${CMAKE_INSTALL_PREFIX}/bin")
SET (LIBDIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
SET (DATADIR "${CMAKE_INSTALL_PREFIX}/share")
SET (INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include/${PACKAGE_NAME}")
SET (PKGDATADIR "${DATADIR}/${PACKAGE_NAME}")
if (${REGINA_INSTALL_TYPE} STREQUAL XDG)
  UNSET (PYLIBDIR)
else ()
  SET (PYLIBDIR "${LIBDIR}/${PACKAGE_NAME}/python")
endif ()
SET (HTMLDIR "${PKGDATADIR}/docs")
SET (ICONDIR "${DATADIR}/icons")
SET (MANDIR "${DATADIR}/man")
SET (XDG_APPS_INSTALL_DIR "${DATADIR}/applications")
SET (XDG_MIME_INSTALL_DIR "${DATADIR}/mime/packages")
SET (XDG_METAINFO_DIR "${DATADIR}/metainfo")

# Useful build directories
SET (ENGINE_INCLUDES "${PROJECT_SOURCE_DIR}/engine" )
SET (ENGINE_LIBRARY regina-engine)

# Paths that we need to escape for @...@ substitution into bash/perl scripts
REGINA_ESCAPE_BASH (CMAKE_SOURCE_DIR)
REGINA_ESCAPE_BASH (CMAKE_INSTALL_PREFIX)
REGINA_ESCAPE_BASH (INCLUDEDIR)
REGINA_ESCAPE_BASH (LIBDIR)
REGINA_ESCAPE_BASH (PACKAGE_BUILD_STRING)
REGINA_ESCAPE_PERL (CMAKE_INSTALL_PREFIX)
REGINA_ESCAPE_PERL (LIBDIR)
REGINA_ESCAPE_PERL (PYLIBDIR)
REGINA_ESCAPE_PERL (PKGDATADIR)

# RPATH support.
IF (NOT DISABLE_RPATH)
  SET(DISABLE_RPATH OFF CACHE BOOL
    "Do not build with rpath.  This option may break installations in non-standard directories, since executables may be unable to find Regina's libraries.  For installations in standard areas such as /usr however, this option is highly recommended." FORCE)
ENDIF (NOT DISABLE_RPATH)

IF (NOT DISABLE_RPATH)
  if (APPLE)
    set(CMAKE_INSTALL_NAME_DIR "${LIBDIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  else (APPLE)
    set(CMAKE_INSTALL_RPATH "${LIBDIR}")
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  endif (APPLE)
ENDIF (NOT DISABLE_RPATH)

# i18n checks.
CHECK_CXX_SOURCE_COMPILES("
  #include \"langinfo.h\"
  int main() { nl_langinfo(CODESET); return 0; }"
  LANGINFO_FOUND )
if(NOT LANGINFO_FOUND)
  MESSAGE(WARNING "langinfo not found: UTF-8 will be used always, and the locale-specific encoding will be ignored.")
endif(NOT LANGINFO_FOUND)

CHECK_CXX_SOURCE_COMPILES("
  #include <stdint.h>
  int128_t x;
  uint128_t y;
  int main() { return 0; }"
  INTERNAL_INT128_T_FOUND )

CHECK_CXX_SOURCE_COMPILES("
  #include <stdint.h>
  __int128 x;
  __uint128 y;
  int main() { return 0; }"
  INTERNAL___INT128_FOUND )

CHECK_CXX_SOURCE_COMPILES("
  #include <stdint.h>
  __int128_t x;
  __uint128_t y;
  int main() { return 0; }"
  INTERNAL___INT128_T_FOUND )

CHECK_CXX_SOURCE_COMPILES("
  unsigned long long x = 0xFFFFFFFFFFFFFFFF;
  int main() { return 0; }"
  NUMERIC_64_FOUND)
CHECK_CXX_SOURCE_COMPILES("
  unsigned long long x = 0xFFFFFFFFFFFFFFFFLL;
  int main() { return 0; }"
  NUMERIC_64_LL_FOUND)

# Dependencies used by all components of Regina

# Note that pkg-config is optional, but it does help us find some libraries
# that we could perhaps not have found otherwise.
# In particular, most build environments will need it to locate Graphviz.
FIND_PACKAGE(PkgConfig)

FIND_PACKAGE(ZLIB)
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
MACRO_LOG_FEATURE(ZLIB_FOUND
  "zlib"
  "Essential: compression support"
  "http://www.gzip.org/zlib/"
  TRUE)

FIND_PACKAGE(LibXml2)
INCLUDE_DIRECTORIES(${LIBXML2_INCLUDE_DIR})
MACRO_LOG_FEATURE(LIBXML2_FOUND
  "libxml2"
  "Essential: XML support"
  "ftp.gnome.org"
  TRUE)

FIND_PACKAGE(GMP)
INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR})
MACRO_LOG_FEATURE(GMP_FOUND
  "GMP/C"
  "Essential: large integer arithmetic support for C"
  "http://gmplib.org/"
  TRUE)

FIND_PACKAGE(GMPXX)
INCLUDE_DIRECTORIES(${GMPXX_INCLUDE_DIR})
MACRO_LOG_FEATURE(GMPXX_FOUND
  "GMP/C++"
  "Essential: large integer arithmetic support for C++"
  "http://gmplib.org/"
  TRUE)

FIND_PACKAGE(ICONV)
INCLUDE_DIRECTORIES(${ICONV_INCLUDE_DIR})
MACRO_LOG_FEATURE(ICONV_FOUND
  "iconv"
  "Essential: internationalisation support"
  "http://www.gnu.org/s/libiconv/"
  TRUE)

FIND_PACKAGE(Jansson)
INCLUDE_DIRECTORIES(${Jansson_INCLUDE_DIR})
MACRO_LOG_FEATURE(Jansson_FOUND
  "Jansson"
  "Essential: JSON support"
  "http://www.digip.org/jansson/"
  TRUE)

IF (NOT DISABLE_PYTHON)
  MESSAGE (STATUS "Searching for a Python installation")

  # Some basic sanity testing on the user's python settings.
  IF (PYTHON_EXECUTABLE)
    UNSET(PYTHON_EXECUTABLE CACHE)
    MESSAGE(FATAL_ERROR "Regina now uses a different method for finding Python. The old PYTHON_EXECUTABLE setting is no longer recognised. Please set Python_EXECUTABLE instead.")
  ENDIF (PYTHON_EXECUTABLE)
  IF (Python_EXECUTABLE)
    IF(${CMAKE_VERSION} VERSION_LESS "3.16.0")
      UNSET(Python_EXECUTABLE CACHE)
      MESSAGE(FATAL_ERROR "The Python_EXECUTABLE setting only works with CMake 3.16 and above. For now please either upgrade your CMake, or else remove (or temporarily hide) any conflicting Python installations so that the automated tools can find the correct Python without assistance.")
    ENDIF(${CMAKE_VERSION} VERSION_LESS "3.16.0")
  ENDIF (Python_EXECUTABLE)

  # Note: FindPython prioritises Python 3 (which is what we want also).
  FIND_PACKAGE(Python COMPONENTS Interpreter Development REQUIRED)

=== python/CMakeLists.txt ===
SET ( SOURCES modulemain.cpp )
ADD_SUBDIRECTORY("algebra")
ADD_SUBDIRECTORY("angle")
ADD_SUBDIRECTORY("census")
ADD_SUBDIRECTORY("dim2")
ADD_SUBDIRECTORY("dim3")
ADD_SUBDIRECTORY("dim4")
ADD_SUBDIRECTORY("enumerate")
ADD_SUBDIRECTORY("file")
ADD_SUBDIRECTORY("foreign")
ADD_SUBDIRECTORY("generic")
ADD_SUBDIRECTORY("hypersurface")
ADD_SUBDIRECTORY("link")
ADD_SUBDIRECTORY("manifold")
ADD_SUBDIRECTORY("maths")
ADD_SUBDIRECTORY("packet")
ADD_SUBDIRECTORY("progress")
ADD_SUBDIRECTORY("snappea")
ADD_SUBDIRECTORY("split")
ADD_SUBDIRECTORY("subcomplex")
ADD_SUBDIRECTORY("surface")
ADD_SUBDIRECTORY("treewidth")
ADD_SUBDIRECTORY("utilities")

ADD_SUBDIRECTORY("testsuite")
ADD_SUBDIRECTORY("sage")

# The module itself is built in the regina/ subdirectory, so that we can
# import the module directly from the source tree if we like.
ADD_SUBDIRECTORY("regina")

# The startup script for users:
CONFIGURE_FILE (
  "${PROJECT_SOURCE_DIR}/python/regina-python.in"
  "${PROJECT_BINARY_DIR}/python/regina-python"
  @ONLY
)

INSTALL(PROGRAMS "${PROJECT_BINARY_DIR}/python/regina-python" DESTINATION "${BINDIR}" COMPONENT Runtime)

=== engine/algebra/CMakeLists.txt ===
# algebra

# Files to compile
SET ( FILES
  abeliangroup.cpp
  covers.cpp
  grouppresentation.cpp
  intersectionform.cpp
  homgrouppresentation.cpp
  markedabeliangroup.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} algebra/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    abeliangroup.h
    grouppresentation.h
    intersectionform.h
    homgrouppresentation.h
    markedabeliangroup.h
    DESTINATION "${INCLUDEDIR}/algebra" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/census/CMakeLists.txt ===
# census

# Files to compile
SET ( FILES
  census.cpp
  closedprimemin.cpp
  compact.cpp
  euler.cpp
  gluingpermsearcher2.cpp
  gluingpermsearcher3.cpp
  gluingpermsearcher4.cpp
  hyperbolic.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} census/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)

ADD_SUBDIRECTORY(explicit)

SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    census.h
    census-impl.h
    gluingperms.h
    gluingperms-impl.h
    gluingpermsearcher.h
    gluingpermsearcher2.h
    gluingpermsearcher3.h
    gluingpermsearcher4.h
    purgeflags.h
    DESTINATION "${INCLUDEDIR}/census" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/enumerate/CMakeLists.txt ===
# enumerate

# Files to compile
SET ( FILES
  hilbertprimal.cpp
  treeconstraint.cpp
  treelp.cpp
  treetraversal.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} enumerate/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)

SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    doubledescription.h
    doubledescription-impl.h
    hilbertcd.h
    hilbertcd-impl.h
    hilbertdual.h
    hilbertdual-impl.h
    hilbertprimal.h
    hilbertprimal-impl.h
    maxadmissible.h
    maxadmissible-impl.h
    ordering.h
    treeconstraint.h
    treeconstraint-impl.h
    treelp.h
    treelp-impl.h
    treetraversal.h
    treetraversal-impl.h
    typetrie.h
    validityconstraints.h
    DESTINATION "${INCLUDEDIR}/enumerate" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/libnormaliz/CMakeLists.txt ===
# normaliz

# Files to compile.
#
# Currently we exclude: nmz_hash, nmz_integral, nmz_nauty
SET ( FILES
  HilbertSeries.cpp
  automorph.cpp
  chunk.cpp
  collection.cpp
  cone.cpp
  cone_dual_mode.cpp
  cone_property.cpp
  descent.cpp
  face_lattice.cpp
  full_cone.cpp
  general.cpp
  input.cpp
  matrix.cpp
  offload_handler.cpp
  options.cpp
  output.cpp
  project_and_lift.cpp
  reduction.cpp
  signed_dec.cpp
  simplex.cpp
  sublattice_representation.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} libnormaliz/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)

# Set the variable in the parent directory
SET(SOURCES ${SOURCES} PARENT_SCOPE)

# Normaliz headers should not be shipped: these are for internal use only.

=== engine/link/CMakeLists.txt ===
# link

# Files to compile
SET ( FILES
  algebra.cpp
  dt.cpp
  examplelink.cpp
  flype.cpp
  gauss.cpp
  homfly.cpp
  jenkins.cpp
  jones.cpp
  link.cpp
  modellinkgraph.cpp
  pass.cpp
  pd.cpp
  reidemeister.cpp
  reidemeister-tangle.cpp
  rewrite.cpp
  sig.cpp
  simplify.cpp
  tangle.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} link/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)

# Set the variable in the parent directory
SET( SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    data-impl.h
    dt-impl.h
    examplelink.h
    gauss-impl.h
    gauss-tangle-impl.h
    graph.h
    jenkins-impl.h
    link.h
    modellinkgraph.h
    modellinkgraph-impl.h
    pd-impl.h
    tangle.h
    DESTINATION "${INCLUDEDIR}/link" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/progress/CMakeLists.txt ===
# progress

# Files to compile
SET ( FILES
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} progress/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)

# Set the variable in the parent directory
SET( SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    progresstracker.h
    DESTINATION "${INCLUDEDIR}/progress" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/triangulation/CMakeLists.txt ===
# triangulation 

# Files to compile
SET ( FILES
  cut.cpp
  example2.cpp
  example3.cpp
  example4.cpp
  facetpairing3.cpp
  facepair.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} triangulation/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)

ADD_SUBDIRECTORY(alias)
ADD_SUBDIRECTORY(detail)
ADD_SUBDIRECTORY(dim2)
ADD_SUBDIRECTORY(dim3)
ADD_SUBDIRECTORY(dim4)
ADD_SUBDIRECTORY(explicit)
ADD_SUBDIRECTORY(generic)

# Set the variable in the parent directory
SET( SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    cut.h
    dim2.h
    dim3.h
    dim4.h
    example.h
    example2.h
    example3.h
    example4.h
    forward.h
    facenumbering.h
    facepair.h
    facetpairing.h
    facetpairing3.h
    facetspec.h
    generic.h
    graph.h
    isosigencoding.h
    isosigtype.h
    pachner.h
    DESTINATION "${INCLUDEDIR}/triangulation" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== python/link/CMakeLists.txt ===
# link

# Files to compile
SET ( FILES
  examplelink.cpp
  link.cpp
  modellinkgraph.cpp
  pylink.cpp
  tangle.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} link/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)

# Set the variable in the parent directory
SET( SOURCES ${SOURCES} PARENT_SCOPE)

=== python/testsuite/CMakeLists.txt ===

CONFIGURE_FILE(
  testall.in
  "${PROJECT_BINARY_DIR}/python/testsuite/testall"
  @ONLY
)
CONFIGURE_FILE(
  testbasic.in
  "${PROJECT_BINARY_DIR}/python/testsuite/testbasic"
  @ONLY
)

# A very basic interpreter to use for testing:
INCLUDE_DIRECTORIES(${Python_INCLUDE_DIRS} ${ENGINE_INCLUDES} "${PROJECT_BINARY_DIR}/engine")
ADD_COMPILE_DEFINITIONS(REGINA_PYTHON_USE_PYTHONPATH=1)
ADD_LINK_OPTIONS(${Python_LINK_OPTIONS})
add_executable(basic
  basic.cpp
  ../gui/pythoninterpreter.cpp
  ../gui/pythonoutputstream.cpp)
target_link_libraries(basic ${ENGINE_LIBRARY} ${Python_LIBRARIES})

IF (WIN32)
  ADD_TEST(python-test bash testall)
  ADD_TEST(python-basic bash testbasic)
  # We do not need to add the engine DLL location to the path, since
  # regina-python (used in testall) and testbasic (directly) do this for us.
ELSE (WIN32)
  ADD_TEST(python-test ./testall)
  ADD_TEST(python-basic ./testbasic)
ENDIF (WIN32)

=== qtui/src/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${Python_INCLUDE_DIRS} ${ENGINE_INCLUDES} "${PROJECT_BINARY_DIR}/engine")

if (REGINA_QT STREQUAL 6)
  SET(LINK_LIBS "${ENGINE_LIBRARY}" Qt6::Widgets Qt6::SvgWidgets)
elseif (REGINA_QT STREQUAL 5)
  SET(LINK_LIBS "${ENGINE_LIBRARY}" Qt5::Widgets Qt5::Svg)
endif ()

ADD_SUBDIRECTORY(icons)
ADD_SUBDIRECTORY(choosers)
ADD_SUBDIRECTORY(foreign)
ADD_SUBDIRECTORY(packets)
ADD_SUBDIRECTORY(syntax)

IF(BUILD_PYTHON_BINDINGS)
  ADD_SUBDIRECTORY(python)
  SET(LINK_LIBS ${LINK_LIBS} ${Python_LIBRARIES})
  ADD_LINK_OPTIONS(${Python_LINK_OPTIONS})
  INCLUDE_DIRECTORIES(${Python_INCLUDE_DIRS})
ENDIF(BUILD_PYTHON_BINDINGS)

IF(LIBGVC_FOUND)
  IF(${GRAPHVIZ_TYPE} STREQUAL Framework)
    IF(GRAPHVIZ_FRAMEWORK MATCHES "xcframework/macos-")
      # An xcframework.
      GET_FILENAME_COMPONENT(GRAPHVIZ_FRAMEWORK_DIR "${GRAPHVIZ_FRAMEWORK}" DIRECTORY)
      INCLUDE_DIRECTORIES("${GRAPHVIZ_FRAMEWORK_DIR}/Headers")
      SET(LINK_LIBS ${LINK_LIBS} ${ZLIB_LIBRARIES} "${GRAPHVIZ_FRAMEWORK}")
    ELSE(GRAPHVIZ_FRAMEWORK MATCHES "xcframework/macos-")
      # An ordinary framework.
      INCLUDE_DIRECTORIES("${GRAPHVIZ_FRAMEWORK}/Headers")
      SET(LINK_LIBS ${LINK_LIBS} ${ZLIB_LIBRARIES} "${GRAPHVIZ_FRAMEWORK}")
    ENDIF(GRAPHVIZ_FRAMEWORK MATCHES "xcframework/macos-")
  ELSEIF(${GRAPHVIZ_TYPE} STREQUAL XCFramework)
    INCLUDE_DIRECTORIES("${GRAPHVIZ_PATH}/Headers")
    SET(LINK_LIBS ${LINK_LIBS} ${ZLIB_LIBRARIES} "${GRAPHVIZ_PATH}/libgraphviz.a")
  ELSE (${GRAPHVIZ_TYPE} STREQUAL Framework)
    INCLUDE_DIRECTORIES("${LIBGVC_INCLUDEDIR}")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${LIBGVC_CFLAGS_OTHER}")
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${LIBGVC_LDFLAGS_OTHER}")

    # Assume that pkg-config is telling us the truth.
    # Note, however, that the graphviz plugins often live in a
    # subdirectory graphviz/ beneath the main library path.
    SET(LINK_LIBS ${LINK_LIBS} ${LIBGVC_LIBRARIES})
    SET(LINK_LIBS ${LINK_LIBS} gvplugin_core gvplugin_dot_layout gvplugin_neato_layout)
    LINK_DIRECTORIES("${LIBGVC_LIBDIR}" "${LIBGVC_LIBDIR}/graphviz")

    # Ubuntu focal (20.04 LTS) has an error where the graphviz plugins
    # fail to link due to missing __XXX_finite symbols from the math
    # library.  It's not clear to me why this happens, and ubuntu focal
    # is the only place I've seen it.  Therefore we hard-code the fix
    # specifically for ubuntu focal.
    IF("${LSB_RELEASE_ID}" STREQUAL Ubuntu AND "${LSB_RELEASE_VERSION}" MATCHES ^20\.04)
      ADD_LINK_OPTIONS(-Wl,--allow-shlib-undefined)
    ENDIF()
  ENDIF (${GRAPHVIZ_TYPE} STREQUAL Framework)
ENDIF(LIBGVC_FOUND)

SET(SOURCES ${SOURCES}
  bigwidget.cpp
  codecchooser.cpp
  columnlayout.cpp
  elidedlabel.cpp
  examplesaction.cpp
  iconcache.cpp
  introdialog.cpp
  main.cpp
  reginamain.cpp
  reginapref.cpp
  reginamanager.cpp
  actionspart.cpp
  exports.cpp
  imports.cpp
  messagelayer.cpp
  newpacketdialog.cpp
  newpackets.cpp
  packetchooser.cpp
  packetcreator.cpp
  packeteditiface.cpp
  packetmanager.cpp
  packettabui.cpp
  packettreeview.cpp
  packetui.cpp
  packetwindow.cpp
  patiencedialog.cpp
  progressdialogs.cpp
  treenav.cpp
  coordinatechooser.cpp
  coordinates.cpp
  pythonmanager.cpp
  recentfilesaction.cpp
  reginaabout.cpp
  reginaprefset.cpp
  reginasupport.cpp
  sharedtempfile.cpp
  shortrunner.cpp
  )

if (APPLE)
  set(REGINA_APP_NAME Regina)

  # Add application and mimetype icons to the app bundle.
  set(REGINA_MACOS_ICONS
    "${CMAKE_CURRENT_SOURCE_DIR}/macos-icons/Assets.car"
    "${CMAKE_CURRENT_SOURCE_DIR}/macos-icons/AppIcon.icns"
    "${CMAKE_CURRENT_SOURCE_DIR}/macos-icons/x-regina.icns")
  set_source_files_properties(${REGINA_MACOS_ICONS} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  set(SOURCES ${SOURCES} ${REGINA_MACOS_ICONS})
else (APPLE)
  set(REGINA_APP_NAME regina-gui)
endif (APPLE)

if (WIN32)
  # Add an icon to the executable.
  set(SOURCES ${SOURCES} regina.rc)
endif (WIN32)

if (${REGINA_INSTALL_TYPE} STREQUAL XDG AND NOT APPLE)
  # Install XDG application icons.
  set (XDGSIZES 16 22 24 32 48 64 128 256)
  foreach (IMG_SIZE ${XDGSIZES})
    INSTALL (FILES "${CMAKE_CURRENT_SOURCE_DIR}/xdg-icons/regina-${IMG_SIZE}.png" DESTINATION "${ICONDIR}/hicolor/${IMG_SIZE}x${IMG_SIZE}/apps" RENAME regina.png)
    INSTALL (FILES "${CMAKE_CURRENT_SOURCE_DIR}/xdg-icons/x-regina-${IMG_SIZE}.png" DESTINATION "${ICONDIR}/hicolor/${IMG_SIZE}x${IMG_SIZE}/mimetypes" RENAME application-x-regina.png)
  endforeach (IMG_SIZE ${XDGSIZES})
endif (${REGINA_INSTALL_TYPE} STREQUAL XDG AND NOT APPLE)

set(REGINA_BUNDLE_DEST bin)

ADD_EXECUTABLE(${REGINA_APP_NAME} MACOSX_BUNDLE WIN32 ${SOURCES})

TARGET_LINK_LIBRARIES(${REGINA_APP_NAME} ${LINK_LIBS})

if (APPLE)
  set_target_properties(${REGINA_APP_NAME}
    PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)

  # Prepare an Info.plist:
  set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PACKAGE_VERSION}")

  # This information will be inserted into the following template (which
  # contains file associations for Regina data files, amongst other things):
  set_target_properties(${REGINA_APP_NAME}
    PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/regina.plist")
elseif (LIBGVC_FOUND AND ${GRAPHVIZ_TYPE} STREQUAL Library AND NOT WIN32)
  # Even if this is a no-rpath install into standard system directories,
  # we still need to be able to link with the graphviz plugins.
  # These plugins typically live within a graphviz-specific directory,
  # and so an rpath for these is still required.
  set_target_properties(${REGINA_APP_NAME}
    PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
endif ()

INSTALL(TARGETS ${REGINA_APP_NAME} DESTINATION "${APPDIR}" COMPONENT Runtime)

# TODO: Use COMPONENT Runtime/Development throughout all install targets.

if (${REGINA_INSTALL_TYPE} STREQUAL XDG AND NOT APPLE)
  # Install desktop files and mimetype handling.
  install(FILES regina.desktop DESTINATION "${XDG_APPS_INSTALL_DIR}"
    COMPONENT Runtime)
  install(FILES regina.metainfo.xml DESTINATION "${XDG_METAINFO_DIR}"
    COMPONENT Runtime)
  install(FILES regina.xml DESTINATION "${XDG_MIME_INSTALL_DIR}"
    COMPONENT Runtime)
  update_xdg_mimetypes("${XDG_MIME_INSTALL_DIR}")
endif (${REGINA_INSTALL_TYPE} STREQUAL XDG AND NOT APPLE)

if (WIN32)
  # Install Windows icons for mimetype handling.
  # It seems that, to keep WiX happy, x-regina.ico needs to be in $BINDIR
  # to avoid an ICE69 error (mismatched components for the ProgId entry).
  # I'd love to hear any advice to the contrary.
  install(FILES x-regina.ico DESTINATION "${BINDIR}" COMPONENT Runtime)
endif (WIN32)

=== debian/changelog ===
regina-normal (7.3-2) unstable; urgency=low

  * Fixed a bug where Link::resolve() would not clear calculated properties,
    which could result in incorrect link invariants being cached.
  * Fixed a memory leak in move assignment for triangulations.

 -- Ben Burton <bab@debian.org>  Thu, 04 May 2023 23:05:55 +1000

regina-normal (7.3-1) unstable; urgency=low

  * New upstream release.
  * Bumped standards-version to 4.6.2 (no changes required).

 -- Ben Burton <bab@debian.org>  Thu, 16 Mar 2023 16:29:13 +1000

=== debian/control ===
Source: regina-normal
Section: math
Priority: optional
Maintainer: Ben Burton <bab@debian.org>
Homepage: http://regina-normal.github.io/
Build-Depends:
    bsdextrautils,
    debhelper (>= 11),
    dh-python,
    cmake (>= 3.12),
    doxygen (>= 1.8.17),
    libcppunit-dev (>= 1.10.2-4),
    libgmp-dev (>= 4.1.4-10),
    libgraphviz-dev,
    libjansson-dev,
    libpopt-dev,
    libqt6svg6-dev,
    libtokyocabinet-dev,
    libxml2-dev,
    pkg-config,
    python3-dev,
    qt6-base-dev,
    shared-mime-info,
    xsltproc,
    zlib1g-dev,
    dpkg-dev (>= 1.16.0)
Standards-Version: 4.6.2

Package: regina-normal
Architecture: any
Section: math
Pre-Depends: ${misc:Pre-Depends}
Depends:
    ${shlibs:Depends},
    ${perl:Depends},
    ${python3:Depends},
    ${misc:Depends}
Recommends: regina-normal-doc (>= 7.3-0), evince | pdf-viewer
Suggests: regina-normal-dev, gap
Description: mathematical software for low-dimensional topology
 Regina is a software package for 3-manifold and 4-manifold topologists,
 with a focus on triangulations, knots and links, normal surfaces, and
 angle structures.
 .
 For 3-manifolds, it includes high-level tasks such as 3-sphere recognition,
 connected sum decomposition and Hakenness testing, comes with a rich
 database of census manifolds, and incorporates the SnapPea kernel for
 working with hyperbolic manifolds.  For 4-manifolds, it offers a range of
 combinatorial and algebraic tools, plus support for normal hypersurfaces.
 For knots and links, Regina can perform combinatorial manipulation,
 compute knot polynomials, and work with several import/export formats.
 .
 Regina comes with a full graphical user interface, as well as Python bindings
 and a low-level C++ programming interface.
 .
 This package includes the graphical user interface and the command-line
 Python interface.  The users' handbook and the API documentation are in
 the separate package regina-normal-doc.

Package: regina-normal-dev
Architecture: any
Section: libdevel
Depends:
    regina-normal (= ${binary:Version}),
    libgmp-dev,
    libxml2-dev,
    zlib1g-dev,
    ${misc:Depends}
Suggests: regina-normal-doc
Description: development files for Regina, the topology software
 Regina is a software package for low-dimensional topologists.  This package
 provides development files for compiling Regina's mathematical engine into
 other projects.
 .
 The calculation engine is provided as a C++ shared library.  For complete
 API documentation, see the package regina-normal-doc.
 .
 Regina focuses on the study of 3-manifold and 4-manifold triangulations,
 knots and links, normal surfaces, and angle structures.  For Regina's
 standard graphical user interface, and for more information about what
 Regina can do, see the package regina-normal.

Package: regina-normal-doc
Architecture: all
Section: doc
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}
Recommends: iceweasel | www-browser
Suggests: regina-normal, regina-normal-dev
Breaks: regina-normal (<< 4.6-2)
Replaces: regina-normal (<< 4.6-2)
Description: documentation for Regina, the topology software
 Regina is a software package for low-dimensional topologists.  This package
 provides a rich users' handbook, complete API documentation for the C++
 calculation engine and Python bindings, and the full specification for
 Regina's XML data file format.
 .
 Regina focuses on the study of 3-manifold and 4-manifold triangulations,
 knots and links, normal surfaces, and angle structures.  For Regina's
 standard graphical user interface, and for more information about what
 Regina can do, see the package regina-normal.

=== debian/tests/control ===
Test-Command: debian/tests/utils-test censuslookup
Features: test-name=utils-censuslookup
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test regconcat
Features: test-name=utils-regconcat
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test regconvert
Features: test-name=utils-regconvert
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test regfiledump
Features: test-name=utils-regfiledump
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test regfiletype
Features: test-name=utils-regfiletype
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test retriangulate
Features: test-name=utils-retriangulate
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test sigcensus
Features: test-name=utils-sigcensus
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test tricensus
Features: test-name=utils-tricensus
Depends: @, bsdextrautils

Test-Command: debian/tests/utils-test trisetcmp
Features: test-name=utils-trisetcmp
Depends: @, bsdextrautils

Test-Command: debian/tests/python-test alltypes
Features: test-name=python-alltypes

Test-Command: debian/tests/python-test angles
Features: test-name=python-angles

Test-Command: debian/tests/python-test bool
Features: test-name=python-bool

Test-Command: debian/tests/python-test bytes
Features: test-name=python-bytes

Test-Command: debian/tests/python-test callbacks
Features: test-name=python-callbacks

Test-Command: debian/tests/python-test census
Features: test-name=python-census

Test-Command: debian/tests/python-test clone
Features: test-name=python-clone

Test-Command: debian/tests/python-test constructors
Features: test-name=python-constructors

Test-Command: debian/tests/python-test discs
Features: test-name=python-discs

Test-Command: debian/tests/python-test docstrings
Features: test-name=python-docstrings

Test-Command: debian/tests/python-test embeddings
Features: test-name=python-embeddings

Test-Command: debian/tests/python-test enumerate
Features: test-name=python-enumerate

Test-Command: debian/tests/python-test equality
Features: test-name=python-equality

Test-Command: debian/tests/python-test euler
Features: test-name=python-euler

Test-Command: debian/tests/python-test exception
Features: test-name=python-exception

Test-Command: debian/tests/python-test facenumbering
Features: test-name=python-facenumbering

Test-Command: debian/tests/python-test faces
Features: test-name=python-faces

Test-Command: debian/tests/python-test file python/testsuite
Features: test-name=python-file

Test-Command: debian/tests/python-test flype
Features: test-name=python-flype

Test-Command: debian/tests/python-test generic
Features: test-name=python-generic

Test-Command: debian/tests/python-test groups
Features: test-name=python-groups

Test-Command: debian/tests/python-test hypersurfaces
Features: test-name=python-hypersurfaces

Test-Command: debian/tests/python-test i18n python/testsuite
Features: test-name=python-i18n

## regina-normal 7.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 INCLUDE( ReginaMacros )
 
 # Version
-SET (PACKAGE_VERSION 7.3)
+SET (PACKAGE_VERSION 7.3.1)
 SET (SNAPPY_VERSION 2.8)
 SET (PACKAGE_STRING "${PACKAGE_PRETTY_NAME} ${PACKAGE_VERSION}")
 
@@ -270,7 +270,7 @@
 # Note that pkg-config is optional, but it does help us find some libraries
 # that we could perhaps not have found otherwise.
 # In particular, most build environments will need it to locate Graphviz.
-FIND_PACKAGE(PkgConfig)
+FIND_PACKAGE(PkgConfig QUIET)
 
 FIND_PACKAGE(ZLIB)
 INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
@@ -319,6 +319,16 @@
   "Essential: JSON support"
   "http://www.digip.org/jansson/"
   TRUE)
+
+IF (NOT DISABLE_UTILS)
+  FIND_PACKAGE(POPT)
+  MACRO_LOG_FEATURE(POPT_FOUND
+    "Popt"
+    "Required for Regina's command-line utilities"
+    "http://rpm5.org/files/popt/"
+    TRUE ""
+    "To disable the command-line utilities, run: cmake -DDISABLE_UTILS=1")
+ENDIF (NOT DISABLE_UTILS)
 
 IF (NOT DISABLE_PYTHON)
   MESSAGE (STATUS "Searching for a Python installation")
@@ -331,10 +341,3 @@
   IF (Python_EXECUTABLE)
     IF(${CMAKE_VERSION} VERSION_LESS "3.16.0")
       UNSET(Python_EXECUTABLE CACHE)
-      MESSAGE(FATAL_ERROR "The Python_EXECUTABLE setting only works with CMake 3.16 and above. For now please either upgrade your CMake, or else remove (or temporarily hide) any conflicting Python installations so that the automated tools can find the correct Python without assistance.")
-    ENDIF(${CMAKE_VERSION} VERSION_LESS "3.16.0")
-  ENDIF (Python_EXECUTABLE)
-
-  # Note: FindPython prioritises Python 3 (which is what we want also).
-  FIND_PACKAGE(Python COMPONENTS Interpreter Development REQUIRED)
-

=== engine/CMakeLists.txt ===
# Engine

# Note: Any flags that need to be picked up by internal compiled engine tools
# (such as mkcensusdb) need to appear *before* the list of subdirectories.

# Pick up generated engine headers (e.g., regina-config.h) as well as
# Regina's standard engine headers.
INCLUDE_DIRECTORIES("${CMAKE_SOURCE_DIR}/engine")
INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}/engine")

# The key-value store is only used internally by the engine (i.e., it
# never appears in the engine headers, only the .cpp sources).
# Therefore we include it only here within engine/, not globally.
INCLUDE_DIRECTORIES(${KVStore_INCLUDE_DIRS})
LINK_DIRECTORIES(${KVStore_LIBRARY_DIRS})

SET ( SOURCES )
# Each of these subdirectories modifies the SOURCE variable,
# adding more source files
ADD_SUBDIRECTORY("algebra")
ADD_SUBDIRECTORY("angle")
ADD_SUBDIRECTORY("census")
ADD_SUBDIRECTORY("core")
ADD_SUBDIRECTORY("data")
ADD_SUBDIRECTORY("enumerate")
ADD_SUBDIRECTORY("file")
ADD_SUBDIRECTORY("foreign")
ADD_SUBDIRECTORY("hypersurface")
ADD_SUBDIRECTORY("libnormaliz")
ADD_SUBDIRECTORY("link")
ADD_SUBDIRECTORY("manifold")
ADD_SUBDIRECTORY("maths")
ADD_SUBDIRECTORY("packet")
ADD_SUBDIRECTORY("progress")
ADD_SUBDIRECTORY("snappea")
ADD_SUBDIRECTORY("split")
ADD_SUBDIRECTORY("subcomplex")
ADD_SUBDIRECTORY("surface")
ADD_SUBDIRECTORY("syntax")
ADD_SUBDIRECTORY("treewidth")
ADD_SUBDIRECTORY("triangulation")
ADD_SUBDIRECTORY("utilities")

# Some C files need to be compiled using the C++ compiler (e.g., snappea,
# where we have added C++ namespaces).
SET_SOURCE_FILES_PROPERTIES( ${SOURCES_C_AS_CPP} PROPERTIES LANGUAGE CXX )

# Ensure that, when building under Windows, the linker is given the full list
# of symbols to export in the DLL.  This avoids the need to manage attributes
# such as __declspec(dllexport) and __declspec(dllimport) within the C++ code.
SET(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

ADD_LIBRARY("regina-engine" SHARED ${SOURCES} )
# All of the libraries that appear in ENGINE_LINK_LIBRARIES feature in
# the engine headers, which means they may be expose to third-party apps
# that build against libregina-engine.
# Note: PUBLIC and PRIVATE only appeard in CMake 2.8.12.
# For compatibility back to 2.8.7 we use LINK_PUBLIC and LINK_PRIVATE instead.
SET(ENGINE_LINK_LIBRARIES ${LIBXML2_LIBRARIES} ${GMP_LIBRARIES} ${GMPXX_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
TARGET_LINK_LIBRARIES(regina-engine
  LINK_PUBLIC ${ENGINE_LINK_LIBRARIES}
  LINK_PRIVATE ${STDFS_LIBRARY} "${ICONV_LIBRARY}" ${ZLIB_LIBRARIES} ${Jansson_LIBRARIES} ${KVStore_LIBRARIES})
SET_TARGET_PROPERTIES(regina-engine PROPERTIES VERSION ${PACKAGE_VERSION})
SET_TARGET_PROPERTIES(regina-engine PROPERTIES SOVERSION ${PACKAGE_VERSION})

SET( HEADERS ${HEADERS} docs.h regina-core.h )
SET( MANS ${MANS} regina-engine-config.1 )

# Build space-separated lists of flags for regine-engine-config:
GET_DIRECTORY_PROPERTY(ENGINE_INCLUDE_DIRECTORIES DIRECTORY .. INCLUDE_DIRECTORIES)
foreach(arg ${ENGINE_INCLUDE_DIRECTORIES})
  SET(RECONFIG_INCLUDE_FLAGS "${RECONFIG_INCLUDE_FLAGS} -I${arg}")
endforeach(arg ${ENGINE_INCLUDE_DIRECTORIES})
foreach(arg ${ENGINE_LINK_LIBRARIES})
  SET(RECONFIG_LINK_FLAGS "${RECONFIG_LINK_FLAGS} ${arg}")
endforeach(arg ${ENGINE_LINK_LIBRARIES})
REGINA_ESCAPE_BASH (RECONFIG_INCLUDE_FLAGS)
REGINA_ESCAPE_BASH (RECONFIG_LINK_FLAGS)
CONFIGURE_FILE (
  regina-engine-config.in
  "${PROJECT_BINARY_DIR}/engine/regina-engine-config"
  @ONLY
)

INSTALL(TARGETS regina-engine
  LIBRARY DESTINATION "${LIBDIR}"
  RUNTIME DESTINATION "${BINDIR}"
  COMPONENT Runtime)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES ${HEADERS} DESTINATION "${INCLUDEDIR}" COMPONENT Development)
  INSTALL(FILES "${CMAKE_BINARY_DIR}/engine/regina-config.h" DESTINATION "${INCLUDEDIR}" COMPONENT Development)
  INSTALL(PROGRAMS "${PROJECT_BINARY_DIR}/engine/regina-engine-config" DESTINATION bin COMPONENT Development)
  INSTALL(FILES regina-engine-config.1 DESTINATION "${MANDIR}/man1" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

# Miscellaneous extras:
ADD_SUBDIRECTORY("doxygen")

=== examples/CMakeLists.txt ===

SET(examplesdir "${PKGDATADIR}/examples")

SET(examples_files
  README.txt
  closed-hyp-census.rga
  closed-or-census.rga
  closed-nor-census.rga
  cusped-hyp-or-census.rga
  cusped-hyp-nor-census.rga
  knot-census.rga
  progress.py
  progress.session
  sample.rga
  tree.py
  tree.session
  triangulation.py
  triangulation.session
  )
INSTALL(FILES ${examples_files} DESTINATION "${examplesdir}")

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,5 @@
+INCLUDE_DIRECTORIES("${CMAKE_SOURCE_DIR}/python/pybind11_v${REGINA_PYBIND11_VERSION}")
+
 SET ( SOURCES modulemain.cpp )
 ADD_SUBDIRECTORY("algebra")
 ADD_SUBDIRECTORY("angle")

=== utils/CMakeLists.txt ===
include_directories(${ENGINE_INCLUDES})
include_directories("${CMAKE_BINARY_DIR}/engine")
include_directories("${POPT_INCLUDE_DIR}")

set(UTILS
  censuslookup
  dgt
  regconcat
  regconvert
  regfiledump
  regfiletype
  retriangulate
  sigcensus
  tricensus
  trisetcmp
  )

foreach(UTIL ${UTILS})
  string(REGEX REPLACE _ - SOURCE_FILE ${UTIL})
  add_executable(${UTIL} ${SOURCE_FILE}.cpp)
  target_link_libraries(${UTIL} ${ENGINE_LIBRARY} ${POPT_LIBRARY})
endforeach(UTIL)

install(TARGETS ${UTILS} DESTINATION "${BINDIR}" COMPONENT Runtime)

ADD_SUBDIRECTORY("testsuite")

=== docs/man/CMakeLists.txt ===

SET(man1dir ${MANDIR}/man1)

SET(man1_files
  censuslookup.1
  dgt.1
  regconcat.1
  regconvert.1
  regfiledump.1
  regfiletype.1
  retriangulate.1
  sigcensus.1
  tricensus.1
  trisetcmp.1
  regina-gui.1
  regina-python.1
  )
INSTALL(FILES ${man1_files} DESTINATION "${man1dir}" COMPONENT Runtime)

=== engine/angle/CMakeLists.txt ===
# angle

# Files to compile
SET ( FILES
  anglestructure.cpp
  anglestructures.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} angle/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    angleflags.h
    anglestructure.h
    anglestructures.h
    DESTINATION "${INCLUDEDIR}/angle" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/file/CMakeLists.txt ===
# file 

# Files to compile
SET ( FILES
  fileinfo.cpp
  globaldirs.cpp)

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} file/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)

ADD_SUBDIRECTORY(xml)

SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    fileformat.h
    fileinfo.h
    globaldirs.h
    DESTINATION "${INCLUDEDIR}/file" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/foreign/CMakeLists.txt ===
# foreign

# Files to compile
SET ( FILES
  dehydration.cpp
  orb.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} foreign/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    dehydration.h
    fromsiglist-impl.h
    isosig.h
    orb.h
    DESTINATION "${INCLUDEDIR}/foreign" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/hypersurface/CMakeLists.txt ===
# hypersurface

# Files to compile
SET ( FILES
  enumerate.cpp
  links.cpp
  matching.cpp
  normalhypersurface.cpp
  normalhypersurfaces.cpp
  tetrahedra.cpp
  triangulate.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} hypersurface/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)

# Set the variable in the parent directory
SET( SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    hypercoords.h
    hyperflags.h
    normalhypersurface.h
    normalhypersurfaces.h
    DESTINATION "${INCLUDEDIR}/hypersurface" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/manifold/CMakeLists.txt ===
# manifold 

# Files to compile
SET ( FILES
  graphloop.cpp
  graphpair.cpp
  graphtriple.cpp
  handlebody.cpp
  lensspace.cpp
  manifold.cpp
  sfs.cpp
  sfsalt.cpp
  simplesurfacebundle.cpp
  snappeacensusmfd.cpp
  torusbundle.cpp
  order.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} manifold/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    graphloop.h
    graphpair.h
    graphtriple.h
    handlebody.h
    lensspace.h
    manifold.h
    notation.h
    sfs.h
    sfsalt.h
    simplesurfacebundle.h
    snappeacensusmfd.h
    torusbundle.h
    DESTINATION "${INCLUDEDIR}/manifold" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/maths/CMakeLists.txt ===
# maths 

ADD_SUBDIRECTORY("spec")

# Files to compile
SET ( FILES
  cyclotomic.cpp
  integer.cpp
  matrix2.cpp
  matrixops.cpp
  numbertheory.cpp
  perm.cpp
  permgroup.cpp
  primes.cpp
  rational.cpp
  seedprimes.cpp
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} maths/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL( FILES
    binom.h
    cyclotomic.h
    integer.h
    laurent.h
    laurent2.h
    matrix.h
    matrix2.h
    matrixops.h
    numbertheory.h
    perm.h
    permgroup.h
    polynomial.h
    primes.h
    rational.h
    vector.h
    DESTINATION "${INCLUDEDIR}/maths" COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== debian/changelog ===
regina-normal (7.3.1-3) unstable; urgency=low

  * Update the previous doxygen patch, since it appears the relevant change
    (modules -> topics) happened in doxygen 1.9.8, not doxygen 1.10.

 -- Ben Burton <bab@debian.org>  Wed, 23 Jul 2025 22:01:29 +1000

regina-normal (7.3.1-2) unstable; urgency=low

  * Fix the fact that GNOME does not recognise the GUI when it is running,
    which was causing a generic icon and window name to appear in the dock.
  * Added some compatibility patches from upstream to support graphviz >= 13
    and doxygen >= 1.10.

 -- Ben Burton <bab@debian.org>  Wed, 23 Jul 2025 11:31:50 +1000

regina-normal (7.3.1-1) unstable; urgency=low

  * New upstream release.
  * Now builds under gcc-13 (closes: #1037840).

 -- Ben Burton <bab@debian.org>  Tue, 08 Jul 2025 21:37:45 +1000

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
     libqt6svg6-dev,
     libtokyocabinet-dev,
     libxml2-dev,
-    pkg-config,
+    pkgconf,
     python3-dev,
     qt6-base-dev,
     shared-mime-info,
@@ -28,6 +28,7 @@
 
 Package: regina-normal
 Architecture: any
+Multi-Arch: no
 Section: math
 Pre-Depends: ${misc:Pre-Depends}
 Depends:
@@ -35,7 +36,7 @@
     ${perl:Depends},
     ${python3:Depends},
     ${misc:Depends}
-Recommends: regina-normal-doc (>= 7.3-0), evince | pdf-viewer
+Recommends: regina-normal-doc (>= 7.3.1-0), evince | pdf-viewer
 Suggests: regina-normal-dev, gap
 Description: mathematical software for low-dimensional topology
  Regina is a software package for 3-manifold and 4-manifold topologists,
@@ -59,6 +60,7 @@
 
 Package: regina-normal-dev
 Architecture: any
+Multi-Arch: no
 Section: libdevel
 Depends:
     regina-normal (= ${binary:Version}),
@@ -82,6 +84,7 @@
 
 Package: regina-normal-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}
